CleanBattlemap = CreateFrame("Frame");
BattlemapScale = 1.0;
local width = 0;
local height = 0;
local CleanBattlemapEvents = {}
BattlefieldMap_LoadUI()

function CleanBattleMap_IsBadTile(xOfs)
  local n = math.floor(xOfs / width + 0.5);
  return n == 0 or n == 3;
end

function CleanBattlemap_FixMap()
  for k,v in pairs ({BattlefieldMapFrame.ScrollContainer.Child:GetChildren()}) do
    if(k == 4) then
      for k2, v2 in pairs({v:GetRegions()}) do
        local _, _, _, xOfs, yOfs = v2:GetPoint();
        if(width == 0) then
          width = v2:GetWidth();
          height = v2:GetHeight();
        end
        if(CleanBattleMap_IsBadTile(xOfs)) then
          v2:Hide();
        end
      end
    end
  end
  BattlefieldMapFrame.BorderFrame.CloseButton:Hide()
  BattlefieldMapFrame.BorderFrame.CloseButtonBorder:Hide()
  BattlefieldMapFrame.BorderFrame.TopLeft:Hide()
  BattlefieldMapFrame.BorderFrame.TopRight:Hide()
  BattlefieldMapFrame.BorderFrame.BottomLeft:Hide()
  BattlefieldMapFrame.BorderFrame.BottomRight:Hide()
  BattlefieldMapFrame.BorderFrame.Bottom:Hide()
  BattlefieldMapFrame.BorderFrame.Top:Hide()
  BattlefieldMapFrame.BorderFrame.Left:Hide()
  BattlefieldMapFrame.BorderFrame.Right:Hide()
  BattlefieldMapFrame:SetScale(BattlemapScale);
end

function CleanBattlemapEvents:ZONE_CHANGED_NEW_AREA(...)
  if(C_Map.GetBestMapForUnit("player") == 1460) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemapEvents:AREA_SPIRIT_HEALER_IN_RANGE(...)
  if(C_Map.GetBestMapForUnit("player") == 1460) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemapEvents:PLAYER_LOGIN(...)
  if(C_Map.GetBestMapForUnit("player") == 1460) then
    CleanBattlemap_FixMap();
  end
end

CleanBattlemap:SetScript("OnEvent", function(self, event, ...)
  CleanBattlemapEvents[event](self, ...);
end);
for k, v in pairs(CleanBattlemapEvents) do
  CleanBattlemap:RegisterEvent(k);
end
